﻿using NationalInstruments.NetworkVariable;
using System;
using System.Windows.Forms;

namespace OPCExample
{
    public partial class Form1 : Form
    {
        private NetworkVariableReader<double> _reader;
        private const string NetworkVariableLocation = @"\\localhost\OPCProcess\Temperature";

        public Form1()
        {
            InitializeComponent();

            ConnectOPCServer();
        }

        private void btnGetData_Click(object sender, EventArgs e)
        {
            NetworkVariableData<double> opcdata = null;
            try
            {
                opcdata = _reader.ReadData();

                txtOpcData.Text = opcdata.GetValue().ToString();
            }
            catch (TimeoutException)
            {
                MessageBox.Show("The read has timed out.", "Timeout");
                return;
            }
        }

        private void ConnectOPCServer()
        {
            _reader = new NetworkVariableReader<double>(NetworkVariableLocation);

            _reader.Connect();

            txtStatus.Text = _reader.ConnectionStatus.ToString();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            _reader.Disconnect();
        }

    }
}
