﻿using NationalInstruments.NetworkVariable;
using System;
using System.Windows.Forms;

namespace OPCExample
{
    public partial class Form1 : Form
    {
        private NetworkVariableWriter<double> _writer;
        private const string NetworkVariableLocation = @"\\localhost\OPCProcess\Temperature";

        public Form1()
        {
            InitializeComponent();

            ConnectOPCServer();
        }

        private void btnWriteData_Click(object sender, EventArgs e)
        {
            double temperature;
            try
            {
                temperature = Convert.ToDouble(txtOpcData.Text);

                _writer.WriteValue(temperature);
            }
            catch (TimeoutException)
            {
                MessageBox.Show("The read has timed out.", "Timeout");
                return;
            }
        }

        private void ConnectOPCServer()
        {
            _writer = new NetworkVariableWriter<double>(NetworkVariableLocation);

            _writer.Connect();

            txtStatus.Text = _writer.ConnectionStatus.ToString();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            _writer.Disconnect();
        }

    }
}
